using System; 
using System.Drawing; 
using System.Collections; 
using System.IO; 


[assembly: OrganismClass("SMMCRITTER")]    //   

//   ࠧࠡ稪 
[assembly: AuthorInformation("Sergey Markov", "sergey@etherscan.com")]   

[CarnivoreAttribute(false)]       // ࠡ뢠 ࠢ來 ⢮

[AnimalSkin("Beetle")]
[MarkingColor(KnownColor.Green)]

// ࠡ뢠 ⢮ । ࠧ
[MatureSize(26)]                    

// Point Based Attributes
 
// ।  㬮砭 ᢠ  祭 ᫥  
// ࠬࠬ  ।⠢  ⥫쭮 । 
// 100 窮
[MaximumEnergyPoints(20)]   // ᨬ쭮 ⢮ ࣨ
[EatingSpeedPoints(0)]      //  
[AttackDamagePoints(0)]     // ,ᨬ ⨢  ⠪
[DefendDamagePoints(0)]     // 䥪⨢ 
[MaximumSpeedPoints(40)]    // ᨬ쭠 ᪮
[CamouflagePoints(0)]       //  
[EyesightPoints(40)]        // 쭮મ


public class SMMCRITTER : Animal 
{ 

	//  ࠬ

	// ⥭,  ஬ ਡ
	PlantState targetPlant = null;          
	AnimalState attackerAnimal = null;      //  ⠪
	MovementVector currentDestination=null; // ࠢ 
	// ६ ࠢ 
	MovementVector tempDestination=null; 	
	const int cruisingSpeed = 5;            //  ଠ쭮 室
	const int fleeingSpeed = 40;            //   

	// ࠬ ஢ 
	MoveCompletedEventArgs e; 			

	// 室 ⢨ ⮬
	bool x10, x11, x12, x13, x14, x15, x16;  		
	bool x1, x2, x3, x4, x5, x6, x7, x8, x9; // 室 ६

	int y0; 	// ६,  ﭨ ⮬

 
	
 
//室 ⢨ ⮬

	void z1()	//
	{
		BeginDefending(attackerAnimal); //  
	}

	void z2() //
	{
		if(currentDestination==null)
		{
			int RandomX= OrganismRandom.Next(0, WorldWidth - 1); 
			int RandomY= OrganismRandom.Next(0, WorldHeight - 1); 
			currentDestination=new MovementVector(new                                                                                                        
				Point(RandomX,RandomY), cruisingSpeed);
			BeginMoving(currentDestination); 
		} 
		else
			BeginMoving(currentDestination); 

	}

	void z3() //  
	{
		BeginMoving(new MovementVector(targetPlant.Position, 2)); 
	}

	void z4() //
	{
		BeginEating(targetPlant); 
	}

	void z5() //ந
	{
		BeginReproduction(null);
	}

	void z6() //
	{
		Vector newVector = Vector.Subtract(attackerAnimal.Position, 
			Position);
		Vector newPositionVector = newVector.Scale(10);
		Point newPosition = Vector.Add(Position, newPositionVector);
		BeginMoving(new MovementVector(newPosition, fleeingSpeed));
	}

	void z7() //	
	{

	}

	void z8() // ࠢ
	{
		//currentDestination=null;
		BeginMoving(getDestination());	
	}

	void z9() // ࠢ
	{
		if(currentDestination!=null)
			BeginMoving(currentDestination);
	}

	
 
	// ⠭  ᮡ ࠡ뢠
	protected override void Initialize() 
	{ 
		Load += new LoadEventHandler(LoadEvent); 
		Idle += new IdleEventHandler(IdleEvent); 
		Attacked += new AttackedEventHandler(AttackedEvent); 
		Born += new BornEventHandler(BornEvent);
		MoveCompleted += 
			new MoveCompletedEventHandler(MoveCompletedEvent);
		AttackCompleted += new 
			AttackCompletedEventHandler(AttackCompletedEvent);
		ReproduceCompleted += new 
			ReproduceCompletedEventHandler(ReproduceCompletedEvent);
	} 

	// 뢠, ᫨ ⢮ 뫮 ஢

	void MoveCompletedEvent(object sender, MoveCompletedEventArgs e)
	{
		x15=true;
		if(e.Reason == ReasonForStop.Blocked)
			x9=true;
		else
			x9=false;
	}

	// 뢠  ஦ ⢠

	private void BornEvent(object sender, BornEventArgs e) 
	{
		y0=4; // 砫쭮 ﭨ
	}

	//  ६

	void InitVar()
	{

		x1=false;
		x2=false;
		x3=false;
		x4=false;
		x5=false;
		x6=false;
		x7=false;
		x8=false;
		x9=false;
		x10=false;
		x11=false;
		x12=false;
		x13=false;
		x14=false;
		x15=false;
		x16=false;
		
	}

	// 樠 ।  室
	void LoadEvent(object sender, LoadEventArgs e) 
	{ 
		InitVar();
		FillVars();
	} 
	// 뢠,  ⢮ 뫮 ⠪
	void AttackedEvent(object sender, AttackedEventArgs e) 
	{ 
		if(e.Attacker.IsAlive) 
		{ 
			x14=true;
		} 
	} 

	public void AttackCompletedEvent(object sender, 
		AttackCompletedEventArgs e) 
	{
	}
    
	// ந 諮 ᯥ譮
	public void ReproduceCompletedEvent(object sender,             
		ReproduceCompletedEventArgs e) 
	{
		x13=true;
	}

	// ⥭
	void fx1()
	{
		ArrayList foundCreatures = Scan(); 
		if(foundCreatures.Count > 0) 
		{ 
			foreach(OrganismState organismState in foundCreatures) 
			{ 
				if(organismState is PlantState) 
				{ 
					targetPlant = (PlantState) organismState; 
					x1=true;

					return;
				} 
			} 
		}
	}

	//⥭ 室  
	void fx2()
	{
		if(x1&&targetPlant.PercentInjured < 0.7 
			|| State.EnergyState == EnergyState.Deterioration)
				x2=true;
	}

	//⥭ ,  
	void fx3()
	{
		if(x1&&WithinEatingRange(targetPlant))
			x3=true;
	}

	
 
//來 ⢮   

	void fx4()
	{
		ArrayList foundAnimals = Scan();
		if(foundAnimals.Count > 0)
		{
			foreach(OrganismState organismState in foundAnimals)
			{
				if(organismState is AnimalState)
				{
					IAnimalSpecies iAS = 
						(IAnimalSpecies) organismState.Species;
					if (iAS.IsCarnivore)
					{
						attackerAnimal = 
							(AnimalState) organismState;
						x4=true;

					}
				}
			}
		}
	}

	// ࠧ
	void fx5()
	{
		if(CanReproduce)
			x5=true;
	}

	//來  
	void fx6()
	{
		x6=!x4;
	}

	//冷 㣮 ࠢ來
	void fx7()
	{
		ArrayList foundAnimals = Scan();
		if(foundAnimals.Count > 0)
		{
			foreach(OrganismState organismState in foundAnimals)
			{
				if(organismState is AnimalState)
				{
					IAnimalSpecies iAS = 
						(IAnimalSpecies) organismState.Species;
					if (!iAS.IsCarnivore&&
							!IsMySpecies(organismState))
					{
						x7=true;
					}
				}
			}
		}
	}

	
 
//  ⥭,  ஬ 
	void fx8()
	{
		if(targetPlant != null) 
		{ 
			targetPlant = (PlantState) LookFor(targetPlant); 
			if(targetPlant != null) 
				x8=true;
		} 
	}

	// ⠭ 祭 室 ६
	void FillVars()
	{
		fx1();
		fx2();
		fx3();
		fx4();
		fx5();
		fx6();
		fx7();
		fx8();
	}

	//⮬
	void switchIdle()
	{

		int yold=y0;

		switch(y0)
		{
			case 0:
				if(common())
				if(!x8)
					y0=4; else 
				if(!x2)
					y0=5; 
				break;

			case 1:
				if(x13)
					y0=4;
				break;

			case 2:
				if(x16)
					y0=6;
				break;

			case 3:
				if(common())
				if(x1&&x2&&x3)
					y0=0; else 
				if(x3&&!x2)
					y0=5;	else 
				if(x15&&x9)
				{
					z8();
					y0=3;
				} else 
				if(x15&&!x9||!x8)
					y0=4; 
				break;

			case 4:
				if(common())
				if(x1&&x2&&x3)
					y0=0; else
				if(x15&&x9)
				{
					z8();
					y0=4; 
				}	else
				if(x1)
					y0=3; else
				if(x15&&!x9)
						z9();
				break;

			case 5:
				if(common())
				if(!x8)
					y0=4; else
				if(x7&&x3&&x8)
					y0=7; else
				if(x1&&x2&&x3)
					y0=0; 
				break;

			case 6:
				if(x6)
					y0=4; else
				if(x15&&x9)
					z8();
				break;

			case 7:
				if(common())
				if(!x1|!x8)
					y0=4; 
				break;
		}


		printState();

		switch(y0)
		{
			case 0:
				z4();
				break;

			case 1:
				
				break;
			case 2:
				z1();
				break;
			case 3:
				z3();
				break;
			case 4:
				z2();
				break;
			case 5:
				z7();
				break;
			case 6:
				z6();
				break;
			case 7:
				z4();
				break;

		}

	}

	//  㯯 室
	bool common()
	{
		if(x4||x14)
			y0=2; else
		if(x5)
		{
			z5();
			y0=1;
		}
		else
			return true;

		return false;

	}


	// 맮 ⮬, ⢫塞   室
	void IdleEvent(object sender, IdleEventArgs e) 
	{ 
		try
		{
			switchIdle(); // 맮 ⮬
		}
		catch (Exception ex)
		{
			WriteTrace("Exception in switchIdle : {0}\n",ex.ToString());
		}
	} 


	//   90 ࠤᮢ
	MovementVector getDestination()
	{
		Point originalDestination =	currentDestination.Destination;
		Vector originalVector = 
			Vector.Subtract(originalDestination, this.Position);
		Vector newVector = originalVector.Rotate(Math.PI / 4);
		Vector unitVector = newVector.GetUnitVector();
		Vector newPositionVector = unitVector.Scale(20);
		Point newPosition = 
			Vector.Add(Position, newPositionVector);
		MovementVector destination=
			new MovementVector(newPosition, cruisingSpeed);
		tempDestination=destination;

		return destination;
	}

	
 
// 뢮 ଠ  ⫠
	void printState()
	{
		WriteTrace("State: "+y0+" ");
		if(x1) 
			WriteTrace("Plant is visible");
			
		if(x2) 
			WriteTrace(", Plant is eatable ");

		if(x3) 
			WriteTrace(", Plant can be eaten");
		if(x4) 
			WriteTrace(", Carnivore is visible");
		if(x5) 
			WriteTrace(", CanReproduce");
		if(x6) 
			WriteTrace(", Carnivore is not visible");
		if(x7) 
			WriteTrace(", Alien Herbivore is visible");
		if(x9) 
			WriteTrace(", Blocked");
		if(x8) 
			WriteTrace(", Plant Exist");

		if(x10) 
			WriteTrace(", x10");
		if(x11) 
			WriteTrace(", x11");
		if(x12) 
			WriteTrace(", x12");
		if(x13) 
			WriteTrace(", x13");
		if(x14) 
			WriteTrace(", x14");
		if(x15) 
			WriteTrace(", x15");
		if(x16) 
			WriteTrace(", x16");
	}

	// 㦥 㭪樨	
	public override void SerializeAnimal(MemoryStream m) 
	{ 
	} 
  
	public override void DeserializeAnimal(MemoryStream m) 
	{ 
	}
}

